debug = true
local anim8 = require 'anim8'

-- Collision detection taken function from http://love2d.org/wiki/BoundingBox.lua
-- Returns true if two boxes overlap, false if they don't
-- x1,y1 are the left-top coords of the first box, while w1,h1 are its width and height
-- x2,y2,w2 & h2 are the same, but for the second box
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

isAlive = true
score = 0
													-- Timers

		createEnemyTimerMax = 0.4
		createEnemyTimer = createEnemyTimerMax
		canShoot = true
		canShootTimerMax = 0.09
		canShootTimer = canShootTimerMax

enemyImg = nil		
enemies = {}
bullets = {}
player = { x = 224, y = 710, speed = 350, img = nil }

function love.load()

	bulletImg = love.graphics.newImage('Devfold_Assets/balls.png')

		local g = anim8.newGrid(32,32, 192,32)
		local m = anim8.newGrid(32,32, 32,98)
		local s = anim8.newGrid(32,32, 32,98)
		local o = anim8.newGrid(32,32, 32, 672)

			boom = anim8.newAnimation (g('1-6',1), 0.1)
			mad = anim8.newAnimation (m(1,'1-3'), 0.05)
			shot = anim8.newAnimation (s(1,'1-3'), 0.07)
			death = anim8.newAnimation (o(1,'1-21'), 0.07)

		enemyImg = love.graphics.newImage ('Devfold_Assets/MANLTA.png')
		playerdeadImg = love.graphics.newImage ('Devfold_Assets/MANLTAMADead.png')
		playeraliveImg = love.graphics.newImage ('Devfold_Assets/MANLT.png')
		playerdashingImg = love.graphics.newImage ('Devfold_Assets/MANLTAMADs.png')
		shooting = love.graphics.newImage ('Devfold_Assets/MANLTAMADshot.png')

end

function love.draw(dt)

	if love.keyboard.isDown('lshift') and isAlive and not love.keyboard.isDown('z') then
			mad:draw(playerdashingImg, player.x, player.y)

	elseif love.keyboard.isDown('z') and canShoot and isAlive or love.keyboard.isDown('z','lshift') and isAlive then							--Shoot!
				shot:draw(shooting, player.x, player.y)

	elseif isAlive and not love.keyboard.isDown('z','lshift') then		
				love.graphics.draw(playeraliveImg, player.x, player.y)
	elseif not isAlive then
		death:draw(playerdeadImg, player.x, player.y)
		else 
	end

		for i,v in ipairs(bullets) do
			boom:draw(bulletImg, v.x, v.y)
		end

	for i, enemy in ipairs(enemies) do
		love.graphics.draw(enemy.img, enemy.x, enemy.y)
	end
	
		love.graphics.print	(score, 0, 0)
		love.graphics.print	("Controls: Arrow Keys; Z; Left Shift", 0, 785)

		if not isAlive then
			love.graphics.print	('Game over. Press r to restart or ~ to quit.', 120, 710)
		end


end
	
	
function love.update(dt)
	boom:update(dt)
	mad:update(dt)
	shot:update(dt)
	death:update(dt, pauseAtEnd)
																		--Death Slow
				if not isAlive then
					player.speed = 150
				end

	if love.keyboard.isDown('`') then						--Quit Key via ` key
		love.event.push('quit')
	end

	
	if love.keyboard.isDown('left') then			--Left and Right Movement
		if player.x > 0 then
			player.x = player.x - (player.speed*dt)
		end
	
		elseif love.keyboard.isDown('right') then
			if player.x < (love.graphics.getWidth() - playeraliveImg:getWidth()) then
				player.x = player.x + (player.speed*dt)
			end
	end
	
	if love.keyboard.isDown('down') then									--Up and Down Movement
		if player.y < (love.graphics.getHeight() - playeraliveImg:getHeight()) then
			player.y = player.y + (player.speed*dt*0.95)
		end

		elseif love.keyboard.isDown('up') then
			if player.y > 0 then
				player.y = player.y - (player.speed*dt*0.95)
			end
	end
	
	if love.keyboard.isDown('z') and canShoot and isAlive then							--Shoot!
		newBullet = { x = player.x, y = player.y, img = bullets }
		table.insert(bullets, newBullet)
		canShoot = false
		canShootTimer = canShootTimerMax
	end
	
	canShootTimer = canShootTimer - (1 * dt)
					if canShootTimer < 0 then
						canShoot = true
					end
	
				for i, bullet in ipairs(bullets) do
					bullet.y = bullet.y - (1500*dt)
					bullet.x = bullet.x - math.random (-2.5,2.5)
					if bullet.y < 0 then
						table.remove(bullets, i)
					end
				end
				
				
	if love.keyboard.isDown('lshift') then
		player.speed = 700
	end

		createEnemyTimer = createEnemyTimer - (1 * dt) 							--Spawn timer

		if createEnemyTimer < 0 then
			createEnemyTimer = createEnemyTimerMax	
				randomNumber = math.random(10, love.graphics.getWidth() - 10)		--Spawner
				newEnemy = { x = randomNumber, y = -10, img = enemyImg }
				table.insert(enemies, newEnemy)
		end

		
		for i, enemy in ipairs(enemies) do	enemy.y = enemy.y + (200 * dt) enemy.x = enemy.x - math.cos(enemy.y/200)
			if enemy.y > 250 then
				enemy.x = enemy.x + math.sin(enemy.y/enemy.x)
				enemy.y = enemy. y + (300 * dt)
			elseif enemy.y > 850 then
				table.remove(enemies, i)
			end

			if enemy.x > 500 then
				enemy.x = math.cos(enemy.y/500) - enemy.y
			end
		end
		

		for i, enemy in ipairs(enemies) do
			for j, bullet in ipairs(bullets) do
				if CheckCollision(enemy.x, enemy.y, enemy.img:getWidth()/2, enemy.img:getHeight()/2.5, bullet.x, bullet.y, 32/1.5, 32/1.5) then
					table.remove(bullets, j)
					table.remove(enemies, i)
					if isAlive then
						score = score + 1
						else score = score + 0
					end
				end
			end

				if CheckCollision(enemy.x, enemy.y, enemy.img:getWidth()/1.5, enemy.img:getHeight()/1.5, player.x, player.y, playeraliveImg:getWidth()/2, playeraliveImg:getHeight()/2) 
					and isAlive then
					table.remove(enemies, i)
					isAlive = false
				end
		end
	
			if not isAlive and love.keyboard.isDown('r') then
																	-- remove all our bullets and enemies from screen
				bullets = {}
				enemies = {}
				player.img = playeraliveImg
																	-- reset timers
				canShootTimer = canShootTimerMax
				createEnemyTimer = createEnemyTimerMax
																	-- move player back to default position
				player.x = 224
				player.y = 710
																	-- reset our game state
				score = 0
				isAlive = true
				createEnemyTimerMax = 0.4
				canShootTimerMax = 0.09
				player.speed = 350
			end

																	--Difficulty Ramp up
				if score > (10) and isAlive then
					createEnemyTimerMax = (createEnemyTimerMax - dt/50)
				end
				
				if score > (99) and isAlive then
					canShootTimerMax = 0.07
				end
end

function love.keyreleased(key)

		if key == 'lshift' then
		player.speed = 350
		player.img = playeraliveImg
		end

end